// Copyright (c) 2014 Dragonchip Ltd.	All rights reserved.
// Auther: Danny Ho
/*********************************/
/*** DC6388FD Header File     ***/
/*********************************/

#ifndef DCFD32_H
#define DCFD32_H
/*---
 SFR
---*/
sfr PORTA		= 0x80;
	sbit PORTA_0   = PORTA^0;
	sbit PORTA_1   = PORTA^1;
	sbit PORTA_2   = PORTA^2;
	sbit PORTA_3   = PORTA^3;
	sbit PORTA_4   = PORTA^4;
	sbit PORTA_5   = PORTA^5;
	sbit PORTA_6   = PORTA^6;
	sbit PORTA_7   = PORTA^7;
sfr SP			= 0x81;
sfr DPL     	= 0x82;
sfr DPH     	= 0x83;
sfr DPL1    	= 0x84;
sfr DPH1    	= 0x85;
sfr DPS			= 0x86;
sfr PCON    	= 0x87;
sfr TCON    	= 0x88;
	sbit IT0  	= TCON^0;
	sbit IE0  	= TCON^1;
	sbit IT1  	= TCON^2;
	sbit IE1  	= TCON^3;
	sbit TR0  	= TCON^4;
	sbit TF0  	= TCON^5;
	sbit TR1  	= TCON^6;
	sbit TF1  	= TCON^7;
sfr TMOD    	= 0x89;
sfr TL0     	= 0x8A;
sfr TL1     	= 0x8B;
sfr TH0     	= 0x8C;
sfr TH1     	= 0x8D;
sfr PAOM     	= 0x8E;
sfr T1_PCNTA    = 0x8F;
sfr PORTB		= 0x90;
	sbit PORTB_0	= PORTB^0;
	sbit PORTB_1	= PORTB^1;
	sbit PORTB_2	= PORTB^2;
	sbit PORTB_3	= PORTB^3;
	sbit PORTB_4	= PORTB^4;
	sbit PORTB_5	= PORTB^5;
	sbit PORTB_6	= PORTB^6;
	sbit PORTB_7	= PORTB^7;
sfr EXIF		= 0x91;
sfr PBOM		= 0x92;
sfr FDB			= 0x93;
sfr PAGESEL		= 0x94;
sfr D_PAGESEL	= 0x95;
sfr DIVL		= 0x96;
sfr DIVH		= 0x97;		
sfr SCON0   	= 0x98;
	sbit RI_0   = SCON0^0;
	sbit TI_0   = SCON0^1;
	sbit RB8_0  = SCON0^2;
	sbit TB8_0  = SCON0^3;
	sbit REN_0  = SCON0^4;
	sbit SM2_0  = SCON0^5;
	sbit SM1_0  = SCON0^6;
	sbit SM0_0  = SCON0^7;
sfr SBUF0   	= 0x99;
sfr IEN2   		= 0x9A;
sfr	PCPUR		= 0x9C;
sfr	PCOM		= 0x9D;
sfr PCCON		= 0x9E;
sfr PCECON		= 0x9F;
sfr PORTC		= 0xA0;
	sbit PORTC_0   = PORTC^0;
	sbit PORTC_1   = PORTC^1;
	sbit PORTC_2	= PORTC^2;
	sbit PORTC_3	= PORTC^3;
	sbit T1_IN0	= PORTC^6;
	sbit T1_IN1	= PORTC^7;
sfr	PDPUR		= 0xA1;
sfr PAPUR		= 0xA2;
sfr PACONL		= 0xA3;
sfr PACONH		= 0xA4;
sfr PAINT		= 0xA5;
sfr PAPND		= 0xA6;
sfr LCNT		= 0xA7;
sfr IEN0		= 0xA8;
	sbit EX0    = IEN0^0;
	sbit ET0    = IEN0^1;
	sbit EX1    = IEN0^2;
	sbit ET1    = IEN0^3;
	sbit ES0   	= IEN0^4;
	sbit ET2    = IEN0^5;
	sbit EL0   	= IEN0^6;
	sbit EA     = IEN0^7;
sfr PDINT   	= 0XA9;
sfr S0RELL   	= 0XAA;
sfr PBPUR		= 0xAB;
sfr PBCONL     	= 0xAC;
sfr PBCONH		= 0xAD;
sfr PBINT     	= 0xAE;
sfr PBPND     	= 0xAF;
sfr PORTD		= 0xB0;
	sbit PORTD_0	= PORTD^0;
	sbit PORTD_1	= PORTD^1;
	sbit PORTD_2	= PORTD^2;
	sbit PORTD_3	= PORTD^3;
	sbit PORTD_4	= PORTD^4;
	sbit PORTD_5	= PORTD^5;
	sbit PORTD_6	= PORTD^6;
	sbit PORTD_7	= PORTD^7;
sfr PDCONL		= 0xB1;
sfr PDCONH		= 0xB2;
sfr PDPND		= 0xB3;
sfr S0DIVINT	= 0xB4;
sfr S0DIVFRA	= 0xB5;
sfr PDOM      	= 0xB6;
sfr IP0      	= 0xB8;
	sbit IP0_0	= IP0^0;
	sbit IP0_1	= IP0^1;
	sbit IP0_2	= IP0^2;
	sbit IP0_3	= IP0^3;
	sbit IP0_4	= IP0^4;
	sbit IP0_5	= IP0^5;
sfr	PEPUR		= 0xB9;
sfr S0RELH   	= 0XBA;
sfr PEINT   	= 0xBB;
sfr SPICON1    	= 0xBC;
sfr SPICON2    	= 0xBD;
sfr SPIBUF     	= 0xBE;
sfr	PEPND		= 0xBF;
sfr PORTE		= 0xC0;
	sbit PORTE_0	= PORTE^0;
	sbit PORTE_1	= PORTE^1;
	sbit PORTE_2	= PORTE^2;
	sbit PORTE_3	= PORTE^3;
	sbit PORTE_4	= PORTE^4;
	sbit PORTE_5	= PORTE^5;
	sbit PORTE_6	= PORTE^6;
	sbit PORTE_7	= PORTE^7;
sfr PECONL		= 0xC1;
sfr PECONH   	= 0xC2;
sfr FPTRL		= 0xC3;
sfr FPTRH		= 0xC4;
sfr16 FPTRHL    = 0xC3;
sfr FPTRH2		= 0xC5;
sfr FOSL		= 0xC6;
sfr FOSH		= 0xC7;
sfr16 FOS    	= 0xC6;
sfr T2CON   	= 0xC8;
	sbit CP_RL2 = T2CON^0;
	sbit C_T2   = T2CON^1;
	sbit TR2    = T2CON^2;
	sbit EXEN2  = T2CON^3;
	sbit EXF2   = T2CON^6;
	sbit TF2    = T2CON^7;
sfr T2MOD   	= 0xC9;
sfr RCAP2L  	= 0xCA;
sfr RCAP2H  	= 0xCB;
sfr TL2     	= 0xCC;
sfr TH2     	= 0xCD;
sfr TXZL		= 0xCE;
sfr TXZH		= 0xCF;
sfr16 TXZ		= 0xCE;
sfr PSW    		= 0xD0;
	sbit P      = PSW^0;
	sbit F1     = PSW^1;
	sbit OV     = PSW^2;
	sbit RS0    = PSW^3;
	sbit RS1    = PSW^4;
	sbit F0     = PSW^5;
	sbit AC     = PSW^6;
	sbit CY     = PSW^7;
sfr	PEOM		= 0xD1;
sfr BTCON		= 0xD2;
sfr BTCNTL		= 0xD3;
sfr BTCNTH		= 0xD4;
sfr BTRCTL		= 0xD5;
sfr BTRCTH		= 0xD6;
sfr16 BTRCT		= 0xD5;
sfr CACON		= 0xD7;
sfr SICON		= 0xD8;
	sbit BD		= SICON^7;
sfr CADATAL		= 0xD9;
sfr CADATAH		= 0xDA;
sfr CACONEX		= 0xDB;
sfr CADATAL2  	= 0xDC;
sfr CADATAH2   	= 0xDD;
sfr CARCTPL    	= 0xDE;
sfr CARCTPH    	= 0xDF;
sfr16 CARCTP	= 0xDE;
sfr ACC     	= 0xE0;
	sbit ACC_0  = ACC^0;
	sbit ACC_1  = ACC^1;
	sbit ACC_2  = ACC^2;
	sbit ACC_3  = ACC^3;
	sbit ACC_4  = ACC^4;
	sbit ACC_5  = ACC^5;
	sbit ACC_6  = ACC^6;
	sbit ACC_7  = ACC^7;
sfr ESRCON		= 0xE1;
sfr RDBA		= 0xE2;
sfr RAPTL		= 0xE3;
sfr RAPTH		= 0xE4;
sfr16 RAPT      = 0xE3;
sfr RACTL		= 0xE5;
sfr FCNT		= 0xE6;
sfr FAS			= 0xE7;
sfr IEN1        = 0xE8;
	sbit EX4	= IEN1^3;
sfr RDBB		= 0xE9;
sfr RBPTL		= 0xEA;
sfr RBPTH		= 0xEB;
sfr16 RBPT      = 0xEA;
sfr RBCTL		= 0xEC;
sfr RCPTL   	= 0xED;
sfr RCPTH  		= 0xEE;
sfr16 RCPT      = 0xED;
sfr FAM			= 0xEF;
sfr B       	= 0xF0;
	sbit B_0  	= B^0;
	sbit B_1  	= B^1;
	sbit B_2  	= B^2;
	sbit B_3  	= B^3;
	sbit B_4  	= B^4;
	sbit B_5  	= B^5;
	sbit B_6  	= B^6;
	sbit B_7  	= B^7;
sfr I2CPREL		= 0xF1;
sfr I2CPREH		= 0xF2;
sfr I2CCTR		= 0xF3;
sfr I2CTXR		= 0xF4;
sfr I2CRXR		= 0xF4;
sfr I2CCR		= 0xF5;
sfr I2CSR		= 0xF5;
sfr SRST       	= 0xF7;
sfr IP1      	= 0xF8;
	sbit IP1_0	= IP1^0;
	sbit IP1_1	= IP1^1;
	sbit IP1_2	= IP1^2;
	sbit IP1_3	= IP1^3;
	sbit IP1_4	= IP1^4;
	sbit IP1_5	= IP1^5;
sfr CLKC0     	= 0xFA;
sfr CLKC1     	= 0xFB;
sfr RTCCMP		= 0xFE;

#endif

/******************************************************************************
* union                         
******************************************************************************/
union datB                       
{
	unsigned char bdat[2];
	unsigned int wdat;
};

#ifdef	FD32_Header

/*------------------------------------------------
DC6688FLT External Byte Registers
For Keil compiler
------------------------------------------------*/
volatile unsigned char pdata PFS	    _at_  	0x0021;

volatile unsigned char pdata LVI		_at_	0x0036;

volatile unsigned char pdata PWM0CON	_at_	0x0069;
volatile unsigned char pdata PWM0DATA	_at_	0x006A;
volatile unsigned char pdata PWM1CON	_at_	0x006B;
volatile unsigned char pdata PWM1DATA	_at_	0x006C;

volatile unsigned char pdata LCDC0		_at_	0x0080;
volatile unsigned char pdata LCDC1		_at_	0x0081;				
volatile unsigned char pdata LCDC2		_at_	0x0082;
volatile unsigned char pdata BLSELL		_at_	0x0083;
volatile unsigned char pdata BLSELH		_at_	0x0084;

volatile unsigned char pdata LCDPL		_at_	0x0085;
volatile unsigned char pdata LCDP		_at_	0x0086;
volatile unsigned char pdata LCDPH		_at_	0x0087;

volatile unsigned char pdata SEG0		_at_	0x0098;
volatile unsigned char pdata SEG1		_at_	0x0099;
volatile unsigned char pdata SEG2		_at_	0x009A;
volatile unsigned char pdata SEG3		_at_	0x009B;
volatile unsigned char pdata SEG4		_at_	0x009C;
volatile unsigned char pdata SEG5		_at_	0x009D;
volatile unsigned char pdata SEG6		_at_	0x009E;
volatile unsigned char pdata SEG7		_at_	0x009F;
volatile unsigned char pdata SEG8		_at_	0x00A0;
volatile unsigned char pdata SEG9		_at_	0x00A1;
volatile unsigned char pdata SEG10		_at_	0x00A2;
volatile unsigned char pdata SEG11		_at_	0x00A3;
volatile unsigned char pdata SEG12		_at_	0x00A4;
volatile unsigned char pdata SEG13		_at_	0x00A5;
volatile unsigned char pdata SEG14		_at_	0x00A6;
volatile unsigned char pdata SEG15		_at_	0x00A7;
volatile unsigned char pdata SEG16		_at_	0x00A8;
volatile unsigned char pdata SEG17		_at_	0x00A9;
volatile unsigned char pdata SEG18		_at_	0x00AA;
volatile unsigned char pdata SEG19		_at_	0x00AB;
volatile unsigned char pdata SEG20		_at_	0x00AC;
volatile unsigned char pdata SEG21		_at_	0x00AD;
volatile unsigned char pdata SEG22		_at_	0x00AE;
volatile unsigned char pdata SEG23		_at_	0x00AF;
volatile unsigned char pdata SEG24		_at_	0x00B0;
volatile unsigned char pdata SEG25		_at_	0x00B1;
volatile unsigned char pdata SEG26		_at_	0x00B2;
volatile unsigned char pdata SEG27		_at_	0x00B3;
volatile unsigned char pdata SEG28		_at_	0x00B4;
volatile unsigned char pdata SEG29		_at_	0x00B5;
volatile unsigned char pdata SEG30		_at_	0x00B6;
volatile unsigned char pdata SEG31		_at_	0x00B7;
volatile unsigned char pdata SEG32		_at_	0x00B8;
volatile unsigned char pdata SEG33		_at_	0x00B9;
volatile unsigned char pdata SEG34		_at_	0x00BA;
volatile unsigned char pdata SEG35		_at_	0x00BB;
volatile unsigned char pdata SEG36		_at_	0x00BC;
volatile unsigned char pdata SEG37		_at_	0x00BD;
volatile unsigned char pdata SEG38		_at_	0x00BE;
volatile unsigned char pdata SEG39		_at_	0x00BF;

volatile unsigned char pdata CLKC2		_at_	0x00C2;

volatile unsigned char pdata LCDVS		_at_	0x00C3;

#else

extern volatile unsigned char pdata PFS;

extern volatile unsigned char pdata LVI;

extern volatile unsigned char pdata PWM0CON;
extern volatile unsigned char pdata PWM0DATA;
extern volatile unsigned char pdata PWM1CON;
extern volatile unsigned char pdata PWM1DATA;

extern volatile unsigned char pdata LCDC0;
extern volatile unsigned char pdata LCDC1;				
extern volatile unsigned char pdata LCDC2;

extern volatile unsigned char pdata BLSELL;
extern volatile unsigned char pdata BLSELH;

extern volatile unsigned char pdata LCDPL;
extern volatile unsigned char pdata LCDP;
extern volatile unsigned char pdata LCDPH;

extern volatile unsigned char pdata SEG0;
extern volatile unsigned char pdata SEG1;
extern volatile unsigned char pdata SEG2;
extern volatile unsigned char pdata SEG3;
extern volatile unsigned char pdata SEG4;
extern volatile unsigned char pdata SEG5;
extern volatile unsigned char pdata SEG6;
extern volatile unsigned char pdata SEG7;
extern volatile unsigned char pdata SEG8;
extern volatile unsigned char pdata SEG9;
extern volatile unsigned char pdata SEG10;
extern volatile unsigned char pdata SEG11;
extern volatile unsigned char pdata SEG12;
extern volatile unsigned char pdata SEG13;
extern volatile unsigned char pdata SEG14;
extern volatile unsigned char pdata SEG15;
extern volatile unsigned char pdata SEG16;
extern volatile unsigned char pdata SEG17;
extern volatile unsigned char pdata SEG18;
extern volatile unsigned char pdata SEG19;
extern volatile unsigned char pdata SEG20;
extern volatile unsigned char pdata SEG21;
extern volatile unsigned char pdata SEG22;
extern volatile unsigned char pdata SEG23;
extern volatile unsigned char pdata SEG24;
extern volatile unsigned char pdata SEG25;
extern volatile unsigned char pdata SEG26;
extern volatile unsigned char pdata SEG27;
extern volatile unsigned char pdata SEG28;
extern volatile unsigned char pdata SEG29;
extern volatile unsigned char pdata SEG30;
extern volatile unsigned char pdata SEG31;
extern volatile unsigned char pdata SEG32;
extern volatile unsigned char pdata SEG33;
extern volatile unsigned char pdata SEG34;
extern volatile unsigned char pdata SEG35;
extern volatile unsigned char pdata SEG36;
extern volatile unsigned char pdata SEG37;
extern volatile unsigned char pdata SEG38;
extern volatile unsigned char pdata SEG39;

extern volatile unsigned char pdata CLKC2;

extern volatile unsigned char pdata LCDVS;

#endif

