; Copyright (c) 2014, Dragonchip Ltd. All rights reserved.
;--------------------------------------------------------------------------------
; Filename : 6388FD32-REV1.2.inc
; Purpose  : Define Registers for DC6388FD
;--------------------------------------------------------------------------------
; VERSION	DATE			AUTHOR		
; 1.2		19 AUG 2014		Danny Ho	 
;--------------------------------------------------------------------------------

$IF (DC6388FD32_INC)
$ELSE
$SET (DC6388FD32_INC)
;;;;;;;;;
;; SFR ;;
;;;;;;;;;
PORTA	DATA	080h
	PORTA_0	BIT 	PORTA.0	;
	PORTA_1	BIT 	PORTA.1	;
	PORTA_2	BIT 	PORTA.2	;
	PORTA_3	BIT 	PORTA.3	;
	PORTA_4	BIT 	PORTA.4	;
	PORTA_5	BIT 	PORTA.5	;
	PORTA_6	BIT 	PORTA.6	;
	PORTA_7	BIT 	PORTA.7	;
SP		DATA	081h
DPL		DATA	082h
DPH		DATA	083h
DPL1	DATA	084h
DPH1	DATA	085h
DPS		DATA	086h
PCON	DATA	087h
TCON	DATA	088h
	IT0  	BIT	TCON.0 ;
	IE0  	BIT	TCON.1 ;
	IT1  	BIT	TCON.2 ;
	IE1  	BIT	TCON.3 ;
	TR0  	BIT	TCON.4 ;
	TF0  	BIT	TCON.5 ;
	TR1  	BIT	TCON.6 ;
	TF1  	BIT	TCON.7 ;
TMOD	DATA	089h
TL0		DATA	08Ah
TL1		DATA	08Bh
TH0		DATA	08Ch
TH1		DATA	08Dh
PAOM	DATA	08Eh
T1_PCNTA	DATA	08Fh
PORTB	DATA	090h	;
	PORTB_0	BIT 	PORTB.0;
	PORTB_1	BIT 	PORTB.1;
	PORTB_2	BIT 	PORTB.2;
	PORTB_3	BIT 	PORTB.3;
	PORTB_4	BIT 	PORTB.4;
	PORTB_5	BIT 	PORTB.5;
	PORTB_6	BIT 	PORTB.6;
	PORTB_7	BIT 	PORTB.7;
EXIF	DATA	091h
PBOM	DATA	092h
FDB		DATA	093h
PAGESEL	DATA	094h
D_PAGESEL	DATA	095h
DIVL	DATA	096h
DIVH	DATA	097h
SCON0	DATA	098h
	RI_0	BIT	SCON0.0;
	TI_0	BIT	SCON0.1;
	RB8_0	BIT	SCON0.2;
	TB8_0	BIT	SCON0.3;
	REN_0	BIT	SCON0.4;
	SM2_0	BIT	SCON0.5;
	SM1_0	BIT	SCON0.6;
	SM0_0	BIT	SCON0.7;
SBUF0	DATA	099h
IEN2	DATA	09Ah
PCPUR	DATA	09Ch
PCCON	DATA	09Eh
PCECON	DATA	09Fh
PORTC	DATA	0A0h	;
	PORTC_0	BIT 	PORTC.0;
	PORTC_1	BIT 	PORTC.1;
	PORTC_2	BIT 	PORTC.2;
	PORTC_3	BIT 	PORTC.3;
	T1_IN0	BIT 	PORTC.6;
	T1_IN1	BIT 	PORTC.7;
PDPUR	DATA	0A1h
PAPUR	DATA	0A2h
PACONL	DATA	0A3h
PACONH	DATA	0A4h
PAINT	DATA	0A5h
PAPND	DATA	0A6h
LCNT	DATA	0A7h
IEN0	DATA	0A8h
	EX0	BIT  	IEN0.0;
	ET0	BIT  	IEN0.1;
	EX1	BIT  	IEN0.2;
	ET1	BIT  	IEN0.3;
	ES0	BIT  	IEN0.4;
	ET2	BIT  	IEN0.5;
	EL0	BIT 	IEN0.6;
	EA	BIT  	IEN0.7;
PDINT	DATA	0A9h
S0RELL	DATA	0AAh
PBPUR	DATA	0ABh
PBCONL	DATA	0ACh
PBCONH	DATA	0ADh
PBINT	DATA	0AEh
PBPND	DATA	0AFh
PORTD	DATA	0B0h	
	PORTD_0	BIT 	PORTD.0	;
	PORTD_1	BIT 	PORTD.1	;
	PORTD_2	BIT 	PORTD.2	;
	PORTD_3	BIT 	PORTD.3	;
	PORTD_4	BIT 	PORTD.4	;
	PORTD_5	BIT 	PORTD.5	;
	PORTD_6	BIT 	PORTD.6	;
	PORTD_7	BIT 	PORTD.7	;
PDCONL	DATA	0B1h
PDCONH	DATA	0B2h
PDPND	DATA	0B3h
S0DIVINT	DATA	0B4h
S0DIVFRA	DATA	0B5h
PDOM	DATA	0B6h
IP0		DATA	0B8h
	IP0_0  	BIT	IP0.0;
	IP0_1  	BIT	IP0.1;
	IP0_2  	BIT	IP0.2;
	IP0_3  	BIT	IP0.3;
	IP0_4  	BIT	IP0.4;
	IP0_5  	BIT	IP0.5;
PEPUR	DATA	0B9h
S0RELH	DATA	0BAh
PEINT	DATA	0BBh
SPICON1	DATA	0BCh
SPICON2	DATA	0BDh
SPIBUF	DATA	0BEh
PEPND	DATA	0BFh
PORTE	DATA	0C0h
	PORTE_0	BIT 	PORTE.0	;
	PORTE_1	BIT 	PORTE.1	;
	PORTE_2	BIT 	PORTE.2	;
	PORTE_3	BIT 	PORTE.3	;
	PORTE_4	BIT 	PORTE.4	;
	PORTE_5	BIT 	PORTE.5	;
	PORTE_6	BIT 	PORTE.6	;
	PORTE_7	BIT 	PORTE.7	;
PECONL	DATA	0C1h
PECONH	DATA	0C2h
FPTRL	DATA	0C3h
FPTRH	DATA	0C4h
FPTRH2	DATA	0C5h
FOSL	DATA	0C6h
FOSH	DATA	0C7h
T2CON	DATA	0C8h
	CP_RL2	BIT	T2CON.0;
	C_T2	BIT	T2CON.1;
	TR2	BIT	T2CON.2;
	EXEN2	BIT	T2CON.3;
	EXF2	BIT	T2CON.6;
	TF2	BIT	T2CON.7;
T2MOD	DATA	0C9h
RCAP2L	DATA	0CAh
RCAP2H	DATA	0CBh
TL2	DATA	0CCh
TH2	DATA	0CDh
TXZL	DATA	0CEh
TXZH	DATA	0CFh
PSW	DATA	0D0h
	P	BIT	PSW.0;
	F1	BIT	PSW.1;
	OV	BIT	PSW.2;
	RS0	BIT	PSW.3;
	RS1	BIT	PSW.4;
	F0	BIT	PSW.5;
	AC	BIT	PSW.6;
	CY	BIT	PSW.7;
PEOM	DATA	0D1h
BTCON	DATA	0D2h
BTCNTL	DATA	0D3h
BTCNTH	DATA	0D4h
BTRCTL	DATA	0D5h
BTRCTH	DATA	0D6h
CACON	DATA	0D7h
SICON	DATA	0D8h
	BD	BIT	SICON.7
CADATAL	DATA	0D9h
CADATAH	DATA	0DAh
CACONEX	DATA	0DBh
CADATAL2	DATA	0DCh
CADATAH2	DATA	0DDh
CARCTPL	DATA	0DEh
CARCTPH	DATA	0DFh
ACC		DATA	0E0h
	ACC_0	BIT  	ACC.0;
	ACC_1	BIT  	ACC.1;
	ACC_2	BIT  	ACC.2;
	ACC_3	BIT  	ACC.3;
	ACC_4	BIT  	ACC.4;
	ACC_5	BIT  	ACC.5;
	ACC_6	BIT  	ACC.6;
	ACC_7	BIT  	ACC.7;
ESRCON	DATA	0E1h
RDBA	DATA	0E2h
RAPTL	DATA	0E3h
RAPTH	DATA	0E4h
RACTL	DATA	0E5h
FCNT	DATA	0E6h
FAS		DATA	0E7h
IEN1	DATA	0E8h
	EX4	BIT  	IEN1.3;
RDBB	DATA	0E9h
RBPTL	DATA	0EAh
RBPTH	DATA	0EBh
RBCTL	DATA	0ECh
RCPTL	DATA	0EDh
RCPTH	DATA	0EEh
FAM	DATA	0EFh
B	DATA	0F0h
	B_0	BIT  	B.0;
	B_1	BIT  	B.1;
	B_2	BIT  	B.2;
	B_3	BIT  	B.3;
	B_4	BIT  	B.4;
	B_5	BIT  	B.5;
	B_6	BIT  	B.6;
	B_7	BIT  	B.7;
I2CPREL	DATA	0F1h
I2CPREH	DATA	0F2h
I2CCTR	DATA	0F3h
I2CTXR	DATA	0F4h
I2CRXR	DATA	0F4h
I2CCR	DATA	0F5h
I2CSR	DATA	0F5h
SRST	DATA	0F7h
IP1	DATA	0F8h
	IP1_0  	BIT	IP1.0;
	IP1_1  	BIT	IP1.1;
	IP1_2  	BIT	IP1.2;
	IP1_3  	BIT	IP1.3;
	IP1_4  	BIT	IP1.4;
	IP1_5  	BIT	IP1.5;
CLKC0	DATA	0FAh
CLKC1	DATA	0FBh
RTCCMP	DATA	0FEh

;;;;;;;;;
;; XFR ;;
;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;DC6088 External Byte Registers
;use MOVX @Rx,A	where x = 0,1
;	MOVX @DPTR,A
;use R0,R1,DPTR
;For Keil compiler, MOV	Rx,#P0CONH, it will ignore upper byte if use R0,R1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
PFS	        XDATA	021h

LVI	        XDATA	036h

PWM0CON		XDATA	069h
PWM0DATA	XDATA	06Ah
PWM1CON		XDATA	06Bh
PWM1DATA	XDATA	06Ch

LCDC0	XDATA	080h
LCDC1	XDATA	081h
LCDC2	XDATA	082h

BLSELL	XDATA	083h
BLSELH	XDATA	084h

LCDPL	XDATA	085h
LCDP	XDATA	086h
LCDPH	XDATA	087h

SEG0	XDATA	098h
SEG1	XDATA	099h
SEG2	XDATA	09Ah
SEG3	XDATA	09Bh
SEG4	XDATA	09Ch
SEG5	XDATA	09Dh
SEG6	XDATA	09Eh
SEG7	XDATA	09Fh
SEG8	XDATA	0A0h
SEG9	XDATA	0A1h
SEG10	XDATA	0A2h
SEG11	XDATA	0A3h
SEG12	XDATA	0A4h
SEG13	XDATA	0A5h
SEG14	XDATA	0A6h
SEG15	XDATA	0A7h
SEG16	XDATA	0A8h
SEG17	XDATA	0A9h
SEG18	XDATA	0AAh
SEG19	XDATA	0ABh
SEG20	XDATA	0ACh
SEG21	XDATA	0ADh
SEG22	XDATA	0AEh
SEG23	XDATA	0AFh
SEG24	XDATA	0B0h
SEG25	XDATA	0B1h
SEG26	XDATA	0B2h
SEG27	XDATA	0B3h
SEG28	XDATA	0B4h
SEG29	XDATA	0B5h
SEG30	XDATA	0B6h
SEG31	XDATA	0B7h
SEG32	XDATA	0B8h
SEG33	XDATA	0B9h
SEG34	XDATA	0BAh
SEG35	XDATA	0BBh
SEG36	XDATA	0BCh
SEG37	XDATA	0BDh
SEG38	XDATA	0BEh
SEG39	XDATA	0BFh

CLKC2	XDATA	0C2h

LCDVS	XDATA	0C3h

$ENDIF
